# Torch Time Stretch

Time-stretch audio clips quickly with PyTorch (CUDA supported)! Additional utilities for searching efficient transformations are included.

[View on PyPI](https://pypi.org/project/torch-time-stretch/) / [View Documentation](https://kentonishi.github.io/torch-time-stretch/)

[![Publish to PyPI](https://github.com/KentoNishi/torch-time-stretch/actions/workflows/publish.yaml/badge.svg)](https://github.com/KentoNishi/torch-time-stretch/actions/workflows/publish.yaml)
[![Run tests](https://github.com/KentoNishi/torch-time-stretch/actions/workflows/test.yaml/badge.svg)](https://github.com/KentoNishi/torch-time-stretch/actions/workflows/test.yaml)
[![PyPI version](https://img.shields.io/pypi/v/torch-time-stretch.svg?style=flat)](https://pypi.org/project/torch-time-stretch/)
[![Number of downloads from PyPI per month](https://img.shields.io/pypi/dm/torch-time-stretch.svg?style=flat)](https://pypi.org/project/torch-time-stretch/)
![Python version support](https://img.shields.io/pypi/pyversions/torch-time-stretch)
[![Code Style: Black](https://img.shields.io/badge/code%20style-black-black.svg)](https://github.com/ambv/black)

## About

This package includes two main features:
* Time-stretch audio clips quickly using PyTorch (with CUDA support)
* Calculate efficient time-stretch targets (useful for augmentation, where speed is more important than precise time-stretches)

> Also check out [torch-pitch-shift](https://github.com/KentoNishi/torch-pitch-shift), a sister project for pitch-shifting.

## Installation
```bash
pip install torch-time-stretch
```

## Usage

### Example

Check out [example.py](https://github.com/KentoNishi/torch-time-stretch/blob/master/example.py) to see `torch-time-stretch` in action!

## Documentation
See the [documentation page](https://kentonishi.github.io/torch-time-stretch/) for detailed documentation!

## Contributing
Please feel free to submit issues or pull requests!
